/*	
 *	fmem3.c
 *
 *	tbV ZN^E[h vO
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Jul 29 04:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"

/* eXgprbg}bvBǂSʃTCY(128x88)E2bit}XNłB */
extern unsigned char BITMAP1[];
extern unsigned char BITMAP2[];

/****************************************************************************
 *
 ****************************************************************************/

#define FMEM_ADDR ((unsigned short*)0xc00000) /* tbṼx[XAhX */
#define TEST_ADDR ((unsigned short*)0xc70000) /* eXgɎg̈̃x[XAhX */
                                              /* EZN^@ł0xc70000`0xc70fff( 4KB) */
                                              /* EubNł0xc70000`0xc7ffff(64KB) */
                                              /* g܂B */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
PIECE_BMP bmp;				/* rbg}bvBf[^{̂̓eXg̈ɒu܂ */

void sector_erase(volatile unsigned short* addr);
void word_program(volatile unsigned short* addr, unsigned short data);

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	PBMP_FILEHEADER* hdr;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();

	/* rbg}bv܂B
	 * BITMAP1BITMAP2wb_͓Ȃ̂ŁAłBITMAP1̃wb_gď܂B
	 */
	hdr = (PBMP_FILEHEADER*)BITMAP1;
	bmp.header = *hdr;
	/*bmp.buf = (unsigned char*)(hdr + 1);  ʂ͂܂c */
	bmp.buf = (unsigned char*)TEST_ADDR; /* ̎vOł́Af[^{̂tbVɒu܂B*/
	                                     /* w܂ŁAf[^{̂̓tbVɓ]܂B    */
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int i, joy, x, y;
	PBMP_FILEHEADER* hdr;
	unsigned short *src, *dst;
	DRAW_OBJECT obj;

	/* pbhԂ擾܂B */
	joy = pcePadGet();

	/* SELECT{^ꂽI܂B */
	if(joy & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/*-------------------- tbV̏F --------------------*/

	/* START{^ꂽAtbṼeXg̈܂B
	 * eXgprbg}bv128x88x2bit=2816byteȂ̂ŁA1ZN^(4096byte)Ɏ܂܂B
	 * A1ZN^Ώ[łB
	 */
	if(joy & TRG_START) sector_erase(TEST_ADDR);

	/* A{^ꂽABITMAP1̃f[^{̂tbVɓ]܂B
	 * B{^ꂽABITMAP2̃f[^{̂tbVɓ]܂B
	 */
	hdr = NULL;
	if(joy & TRG_A) hdr = (PBMP_FILEHEADER*)BITMAP1;
	if(joy & TRG_B) hdr = (PBMP_FILEHEADER*)BITMAP2;
	if(hdr != NULL) {
		src = (unsigned short*)(hdr + 1); /* ]rbg}bvf[^{̂̐擪AhX */
		dst = TEST_ADDR;                  /* ]̃tbV̈̐擪AhX */
		for(i = 0; i < hdr->buf_size / sizeof(unsigned short); i++) { /* 2oCgPʂŏ݂܂ */
			word_program(dst++, *src++);
		}
	}

	/*-------------------- tbV̏F܂ --------------------*/

	/* Ô߉ʏB
	 * eXgprbg}bv͑SʃTCYȂ̂ŁAۂɂ͏svłB
	 */
	memset(vbuff, 0, sizeof vbuff);

	/* rbg}bv`܂B
	 * ܂rbg}bvf[^{̂tbVɓ]ĂȂ΁A
	 * S~`܂B
	 */
	pceLCDSetObject(&obj, &bmp, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	pceLCDDrawObject(obj);

	/* @\܂B */
	pceFontSetType(0x80); pceFontSetTxColor(0); pceFontSetBkColor(3);
	x = DISP_X - 5 * 10; y = DISP_Y - 10 * 4;
	pceFontSetPos(x, y); pceFontPutStr("SEL: I "); y += 10;
	pceFontSetPos(x, y); pceFontPutStr("STA:  "); y += 10;
	pceFontSetPos(x, y); pceFontPutStr(" A :#1"); y += 10;
	pceFontSetPos(x, y); pceFontPutStr(" B :#2"); y += 10;

	/* ʓ]B */
	pceLCDTrans();
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
}

/****************************************************************************
 *	sector_erase
 ****************************************************************************/

void
sector_erase(volatile unsigned short* addr)
{
	volatile unsigned short* c1p = FMEM_ADDR + 0x5555;
	volatile unsigned short* c2p = FMEM_ADDR + 0x2aaa;
	unsigned char saveNMI;

DISABLE;
	/* EHb`hbO^C}~B */
	saveNMI = bWD_EN_EWD;
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = 0;

	/* ZN^[hɓ܂B */
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0x80;
	*c1p = 0xaa;
	*c2p = 0x55;

	/* ZN^̔Cӂ̃AhXɁA0x30݂܂B
	 * ZN^̐擪AhXłȂĂ\܂B
	 * ޒlԈႦƁAubN`bv(!!)ɂȂĂ܂\܂B
	 * ޒĺw0x30xłI΂ɊԈႦȂ悤ɁI
	 */
	*addr = 0x30;

#if 1
	/* ҂܂B
	 * * ҂̕@ɂ́AuData# Polling(DQ7)vƁuToggle Bit(DQ6)v̓ނ̕@܂B
	 *   ́AuData# Polling(DQ7)vg܂B
	 * * f[^V[gɂƁAuData# Polling(DQ7)vuToggle Bit(DQ6)v̐̂ƂɁA
	 *   uData# Polling(DQ7)vuToggle Bit(DQ6)vLɂȂ܂ł̃^C~O̐܂B
	 *   u݃[h4TCNځA[h6TCNڈȍ~ɗLvƏĂ܂B
	 *   ꌩA|[O[v̑Oɂ̃EFCgȂ΂Ȃ̂Ǝv܂Ał͂܂B
	 *   u݃[h4TCNځvƂ́A
	 *	*c1p = 0xaa;	1TCN
	 *	*c2p = 0x55;	2TCN
	 *	*c1p = 0xa0;	3TCN
	 *	*addr = data;	4TCN
	 *			L
	 *   ƂӖłBEFCĝƂlKv͂܂B
	 *   lɁAu[h6TCNځvƂ́A
	 *	*c1p = 0xaa;	1TCN
	 *	*c2p = 0x55;	2TCN
	 *	*c1p = 0x80;	3TCN
	 *	*c1p = 0xaa;	4TCN
	 *	*c2p = 0x55;	5TCN
	 *	*addr = 0x30;	6TCN
	 *			L
	 *   ƂӖłBEFCĝƂlKv͂܂B
	 */
	while(*addr != 0xffff) { /*󃋁[v*/ }
#else
	/* uToggle Bit(DQ6)vgȂAvOɂȂ܂AȂ肭܂B
	 * * ̃R[h́AP/ECEJ[lfmacc2.cŃRgAEgĂ̂قƂǂ̂܂܂̃Rs[łB
	 *   f[^V[gɂƁA⏑݂܂ŁAbit6̓ǂݏo0<->1JԂ͂Ȃ̂łA
	 *   ۂɎĂ݂ƁAbit60ŒɂȂĂ܂悤łB
	 *   ȂAf[^V[gǂ̓ɂȂȂ̂AsłB
	 *   P/ECEJ[lł̃R[hRgAEgĂ̂Al̖ɂԂł傤H
	 *   ܂uData# Polling(DQ7)v̕ȒPȂ̂ŁAuToggle Bit(DQ6)v͍lȂƂɂ܂B
	 * * uToggle Bit(DQ6)vŊ҂sĂ܂ƁAĂȂɂ炸bit6]Ȃ̂ŁA
	 *   OɊ҂𔲂Ă܂AŊ荞݂Ă܂܂B
	 *   ƁA҂Ă荞݂āAtbV̊荞݃[`ɃWv܂B
	 *   Ƃ낪AtbV͂܂ʏ̓ǂݏo[hɕAĂȂ̂ŁA
	 *   荞݃[`̃vOǂݏo܂B
	 *   ̌ʁAقĖ\AAhXG[ȂǂTRAP肵܂B
	 *   (TRAPꍇ́Aȃ^C~OŃtbVʏ̓ǂݏo[hɕÂł傤B
	 *    tbVʏ̓ǂݏo[hɕAȂ΁ATRAP\vOȂ͂łB)
	 */
	{
		unsigned short an, ao = *addr;
		while(1) {
			an = *addr;
			if(!((an ^ ao) & 0x40)) break;
			ao = an;
		}
	}
#endif

	/* AIɃZN^[h𔲂Ă܂B
	 * \tgEFAID[hCFING[[ĥ悤ɁA
	 * IɃ[h𔲂R}h𔭍sKv͂܂B
	 */

	/* EHb`hbO^C}B */
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = saveNMI;
ENABLE;
}

/****************************************************************************
 *	word_program
 ****************************************************************************/

/* ̎vOł́A킩₷D̂߂ɁA
 * 1[h݂̏ƂɊ荞݋֎~/sĂ܂B
 * ł͒x̂ŁAۂ̃vOł
 *	荞݋֎~->Sf[^->荞݋
 * ƂׂłBP/ECEJ[lĂ܂B
 */
void
word_program(volatile unsigned short* addr, unsigned short data)
{
	volatile unsigned short* c1p = FMEM_ADDR + 0x5555;
	volatile unsigned short* c2p = FMEM_ADDR + 0x2aaa;
	unsigned char saveNMI;

DISABLE;
	/* EHb`hbO^C}~B */
	saveNMI = bWD_EN_EWD;
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = 0;

	/* ɏ񂾏ꍇ̑΍łB
	 * * ꂩ珑ޗ̈(addr)A炩ߊmɏĂ̂Ȃ΁Ȃ΍͕svłB
	 *   ̎vOł́AtbVɕʂ̃f[^㏑ŝŁA
	 *   ̂悤ȑ΍Ƃ܂B
	 * * [h݂ɂA1̃rbg0ɂ邱Ƃ͂ł܂A0̃rbg1ɂ邱Ƃ͂ł܂B
	 *   ܂ŏIʂ́Ã݂tbV̒lƏޒlANDlɂȂ܂B
	 *   ŁA炩ߏޒl(data)Ã݂̒lANDlɂĂ܂B
	 *   datâ܂܂̒lŁuData# Polling(DQ7)v҂sƁAiɏIȂ̂ŁAvӂłB
	 * * datâ܂܏񂾂A̒ldata̒lANDƂlɂȂ邩cƎvAłȂ悤łB
	 *   0̃rbg1ނƁAHɌʂsȒlɂȂ邩AuData# Polling(DQ7)vȂƂ悤łB
	 *   ̂͂KvłB
	 */
	data &= *addr;

	/* [h݃[hɓ܂B */
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0xa0;

	/* ރAhXɏރf[^݂܂iςȓ{(^^;j */
	*addr = data;

#if 1
	/* ݊҂܂B
	 * * ҂̕@ɂ́AuData# Polling(DQ7)vƁuToggle Bit(DQ6)v̓ނ̕@܂B
	 *   ́AuData# Polling(DQ7)vg܂B
	 * * f[^V[gɂƁAuData# Polling(DQ7)vuToggle Bit(DQ6)v̐̂ƂɁA
	 *   uData# Polling(DQ7)vuToggle Bit(DQ6)vLɂȂ܂ł̃^C~O̐܂B
	 *   u݃[h4TCNځA[h6TCNڈȍ~ɗLvƏĂ܂B
	 *   ꌩA|[O[v̑Oɂ̃EFCgȂ΂Ȃ̂Ǝv܂Ał͂܂B
	 *   u݃[h4TCNځvƂ́A
	 *	*c1p = 0xaa;	1TCN
	 *	*c2p = 0x55;	2TCN
	 *	*c1p = 0xa0;	3TCN
	 *	*addr = data;	4TCN
	 *			L
	 *   ƂӖłBEFCĝƂlKv͂܂B
	 *   lɁAu[h6TCNځvƂ́A
	 *	*c1p = 0xaa;	1TCN
	 *	*c2p = 0x55;	2TCN
	 *	*c1p = 0x80;	3TCN
	 *	*c1p = 0xaa;	4TCN
	 *	*c2p = 0x55;	5TCN
	 *	*addr = 0x30;	6TCN
	 *			L
	 *   ƂӖłBEFCĝƂlKv͂܂B
	 */
	while(*addr != data) { /*󃋁[v*/ }
#else
	/* uToggle Bit(DQ6)vgȂAvOɂȂ܂AȂ肭܂B
	 * * ̃R[h́AP/ECEJ[lfmacc2.cŃRgAEgĂ̂قƂǂ̂܂܂̃Rs[łB
	 *   f[^V[gɂƁA⏑݂܂ŁAbit6̓ǂݏo0<->1JԂ͂Ȃ̂łA
	 *   ۂɎĂ݂ƁAbit60ŒɂȂĂ܂悤łB
	 *   ȂAf[^V[gǂ̓ɂȂȂ̂AsłB
	 *   P/ECEJ[lł̃R[hRgAEgĂ̂Al̖ɂԂł傤H
	 *   ܂uData# Polling(DQ7)v̕ȒPȂ̂ŁAuToggle Bit(DQ6)v͍lȂƂɂ܂B
	 * * uToggle Bit(DQ6)vŊ҂sĂ܂ƁAĂȂɂ炸bit6]Ȃ̂ŁA
	 *   OɊ҂𔲂Ă܂AŊ荞݂Ă܂܂B
	 *   ƁA҂Ă荞݂āAtbV̊荞݃[`ɃWv܂B
	 *   Ƃ낪AtbV͂܂ʏ̓ǂݏo[hɕAĂȂ̂ŁA
	 *   荞݃[`̃vOǂݏo܂B
	 *   ̌ʁAقĖ\AAhXG[ȂǂTRAP肵܂B
	 *   (TRAPꍇ́Aȃ^C~OŃtbVʏ̓ǂݏo[hɕÂł傤B
	 *    tbVʏ̓ǂݏo[hɕAȂ΁ATRAP\vOȂ͂łB)
	 * * [h͊܂łɒԂ̂ŁAL̏Ǐ󂪂قڊmɔ܂B
	 *   ݃[h͊܂ł̎ԂẐŁAuToggle Bit(DQ6)vgĂȂ܂B
	 *   Ɗ҂łĂȂĂA荞݂Oɖ{ɊĂ܂łB
	 *   gOĂȂƂɕς͂Ȃ̂ŁAςuToggle Bit(DQ6)v̎gp͔قǂłB
	 */
	{
		unsigned short an, ao = *addr;
		while(1) {
			an = *addr;
			if(!((an ^ ao) & 0x40)) break;
			ao = an;
		}
	}
#endif

	/* 1[h񂾂AIɃ[h݃[h𔲂Ă܂B
	 * \tgEFAID[hCFING[[ĥ悤ɁA
	 * IɃ[h𔲂R}h𔭍sKv͂܂B
	 */

	/* EHb`hbO^C}B */
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = saveNMI;
ENABLE;
}
